BeerOverflow.Web/Controllers/ApiControllers/CountryController.cs
using AutoMapper;
using BeerOverFlow.Models;
using BeerOverFlow.Services.Contracts;
using BeerOverFlow.Services.ModelsDTo;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;

namespace BeerOverFlow.Controllers.ApiControllers
{

    [Route("api/[controller]")]
    [ApiController]
    public class CountryController : ControllerBase
    {
        private readonly ICountryService service;
        IMapper mapper;

        public CountryController(ICountryService service, IMapper mapper)
        {
            this.service = service ?? throw new ArgumentNullException(nameof(service));
            this.mapper = mapper;
        }

        [HttpGet]
        public IActionResult Get()
        {
            var result = service.GetCountry(mapper);
            if (result == null)
            {
                return BadRequest();
            }
            var res = mapper.Map<ICollection<CountryViewModel>>(result);
            return Ok(res);
        }
        [HttpGet]
        [Route("{id}")]

        public IActionResult Get(int id)
        {
            var result = service.GetCountry(mapper, id);
            if (result == null)
            {
                return BadRequest(id);
            }
            return Ok(result);
        }

        [HttpPost]
        public IActionResult Post(CountryViewModel country)
        {
            var tempDTO = mapper.Map<CountryDTO>(country);
            var finalResult = service.Create(tempDTO, mapper);
            if (finalResult != null)
            {
                return Ok(finalResult);
            }
            return BadRequest(country);
        }
        [HttpPut]
        [Route("{id}")]
        public IActionResult Put(CountryViewModel country, int id)
        {
            //TODO
            var holder = this.mapper.Map<CountryDTO>(country);
            holder.CountryId = id;
            var inst = service.Update(country.CountryName, holder, mapper);
            if (inst != null)
            {
                return Ok(inst);
            }
            return BadRequest(holder);
        }

        [HttpDelete]
        [Route("{id}")]

        public IActionResult Delete(int id)
        {
            if (service.Delete(id))
            {
                return Ok("Country was deleted");
            }
            return BadRequest();
        }
    }

}

BeerOverflow.Web/Controllers/BreweryController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using AutoMapper;
using BeerOverflow.Services.ModelsDTo.WebModels;
using BeerOverFlow.Models;
using BeerOverFlow.Services.Contracts;
using BeerOverFlow.Services.ModelsDTo;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.Extensions.Logging;

namespace BeerOverflow.Web.Controllers
{
   
    public class BreweryController : Controller
    {
        private readonly IBreweryService brService;
        private readonly ICountryService ctrCountry;        
        IMapper mapper;    
       

        public BreweryController(IBreweryService brService,
            ICountryService ctrCountry, IMapper mapper)
        {
            this.brService = brService;
            this.mapper = mapper;        
            this.ctrCountry = ctrCountry;
        }

        [Authorize(Roles = "Admin")]
        [HttpGet]
        public IActionResult CreateBrewery()
        {
            var countryViewModels = mapper.Map<ICollection<CountryViewModel>>(ctrCountry.GetCountry(mapper));
           
            ViewData["CountryList"] = new SelectList(countryViewModels, "CountryId", "CountryName");

            return View();
        }

        [HttpGet]
        public IActionResult ListBreweries()
        {
            var res = brService.GetBreweries(mapper);
            var x = mapper.Map<ICollection<BreweryViewModel>>(res);
            return View("ListBreweries", x);
        }

        [Authorize(Roles = "Admin")]
        [HttpGet]
        public IActionResult EditBrewery(int id)
        {
            
            var countryViewModels = 
                mapper.Map<ICollection<CountryViewModel>>(ctrCountry.GetCountry(mapper));           
            ViewData["CountryList"] = new SelectList(countryViewModels, "CountryId", "CountryName");

            var res = brService.GetBrewery(id, mapper);

            if (res == null)
            {
                return NotFound();
            }
            return View(mapper.Map<BreweryViewModel>(res));
        }

        [Authorize(Roles = "Admin")]
        [HttpPost]
        public IActionResult EditBrewery(int id,BreweryViewModel brewery)
        {
            brewery.BreweryId = id;
            var res = brService.Update(mapper.Map<BreweryDTO>(brewery), mapper);
            return RedirectToAction("ListBreweries");
            //return RedirectToActionPermanent("BeerDetails", new { id = res.BreweryId });
        }

        [Authorize(Roles = "Admin")]
        [HttpPost]
        public IActionResult CreateBrewery(BreweryViewModel brewery)
        {
            var res = brService.Create(mapper.Map<BreweryDTO>(brewery), mapper);
            return RedirectToAction("ListBreweries");
        }

        [Authorize(Roles = "Admin")]
        [HttpGet]
        public IActionResult DeleteBrewery(int id)
        {
            var res = brService.Delete(id);
            return RedirectToAction("ListBreweries");
        }

        [HttpGet] 
        public IActionResult BreweryDetails(int id)
        {
            ICollection<BeerDTO> beersRaw = brService.GetBeers(id, mapper);
            ICollection<BeerViewModel> beers = new List<BeerViewModel>();
            foreach (var beer in beersRaw)
            {
                beers.Add(mapper.Map<BeerViewModel>(beer));
            }

            return View(beers);
        }
    }
}

BeerOverflow.Web/Controllers/ReviewController.cs
using System;
using System.Security.Claims;
using AutoMapper;
using BeerOverflow.Services.Services.Contracts;
using BeerOverFlow.Services.Contracts;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;

namespace BeerOverflow.Web.Controllers
{
    [Authorize(Roles = "Member,Admin")]
    public class ReviewController : Controller
    {
        private readonly ILogger<ReviewController> _logger;
        IReviewService service;
        IBeerService beerService;
        IUserService userService;
        IMapper mapper;

        public ReviewController(ILogger<ReviewController> logger,
            IReviewService service, IMapper mapper, IBeerService beerService, IUserService userService)
        {
            this.service = service ?? throw new ArgumentNullException(nameof(service));
            this.beerService = beerService ?? throw new ArgumentNullException(nameof(beerService));
            this.mapper = mapper ?? throw new ArgumentNullException(nameof(service));
            this.userService = userService ?? throw new ArgumentNullException(nameof(service));
            _logger = logger;
        }
        public IActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public IActionResult PostReview(string reviewText, int beerId)
        {
            int userId = Convert.ToInt32(this.User.FindFirstValue(ClaimTypes.NameIdentifier));
            if(!userService.UserIsBanned(userId))
            {
                service.PostReview(reviewText, beerId, userId);
            }
            var beer = beerService.BeerDetails(beerId, mapper);
            return RedirectToAction("BeerDetails", "Beers", beer);
        }
        public IActionResult LikeReview(int id, int beerId)
        {
            int userId = Convert.ToInt32(this.User.FindFirstValue(ClaimTypes.NameIdentifier));
            service.LikeReview(id, userId);
            var beer = beerService.BeerDetails(beerId, mapper);
            return RedirectToAction("BeerDetails", "Beers", beer);
        }

        public IActionResult DislikeReview(int id, int beerId)
        {
            int userId = Convert.ToInt32(this.User.FindFirstValue(ClaimTypes.NameIdentifier));
            service.DislikeReview(id, userId);
            var beer = beerService.BeerDetails(beerId, mapper);
            return RedirectToAction("BeerDetails", "Beers", beer);
        }

        public IActionResult FlagReview(int id, int beerId)
        {
            var result = service.FlagReview(id);
            if (!result)
                return View("Error");
            var beer = beerService.BeerDetails(beerId, mapper);
            return RedirectToAction("BeerDetails", "Beers", beer);
        }

        [Authorize(Roles = "Admin")]
        public IActionResult DeleteReview(int id, string name)
        {
            service.DeleteReview(id);
            var reviewList = userService.UserReview(name);
            return View("~/Views/User/ShowReviews.cshtml", reviewList);
        }
    }
}

BeerOverflow.Web/Controllers/UserController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using AutoMapper;
using BeerOverflow.Services.ModelsDTo.WebModels;
using BeerOverflow.Web.Models.UserViewModels;
using BeerOverFlow.Models;
using BeerOverFlow.Services.Contracts;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;

namespace BeerOverflow.Web.Controllers
{
    public class UserController : Controller
    {
        private readonly IUserService service;
        private readonly ILogger<BeersController> logger;
        private readonly IBeerService _beerService;
        private IMapper mapper { get; }

        public UserController(IMapper mapper, IUserService service, ILogger<BeersController> logger, IBeerService _beerService)
        {
            this.mapper = mapper;
            this.service = service;
            this.logger = logger;
            this._beerService = _beerService;
        }
        //GET: User

       [HttpGet]
        public async Task<ActionResult> ListUsers()
        {
            var res = await service.GetAllUsersAsync(mapper);
            var final = mapper.Map<ICollection<ListUserViewModel>>(res);
            return View(final);
        }

        // GET: User/Details/5
        [HttpGet]
        public IActionResult Details(int id)
        {
            var res = service.GetUserById(id, mapper);
            return View();
        }

        // GET: User/Create
        [HttpGet]
        public ActionResult Create()
        {
            return View();
        }

        // POST: User/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Create(IFormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction(nameof(ListUsers));
            }
            catch
            {
                return View();
            }
        }

        // GET: User/Edit/5
        [HttpGet]
        public IActionResult Edit(int id)
        {
            return View();
        }

        // POST: User/Edit/5
        [HttpPost]
        //[ValidateAntiForgeryToken]
        public IActionResult Edit(int id, IFormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction(nameof(ListUsers));
            }
            catch
            {
                return View();
            }
        }

        [HttpGet]
        public IActionResult DeleteUser(int id)
        {
            var result = service.Delete(id);
            return RedirectToAction("ListUsers");
        }

        [HttpPost]
        public IActionResult AddToList(int beerId, string operation)
        {
            int userId = Convert.ToInt32(this.User.FindFirstValue(ClaimTypes.NameIdentifier));
            if (operation.ToLower().Contains("wishlist"))
                service.AddToWishlist(beerId, userId);
            else
                service.AddToDranklist(beerId, userId);
            var beer = _beerService.BeerDetails(beerId, mapper);
            return RedirectToAction("BeerDetails", "Beers", beer);
        }

        [HttpGet]
        //[Route("User/BanUser/{id}")]
        public IActionResult BanUser(int id)
        {
            bool result = service.BanUser(id);
            if (result == false)
                return RedirectToAction("Error");
            return RedirectToAction("ListUsers");
        }
       

        [HttpGet]
        public IActionResult UserAccount(string id)
        {
            UserDetailsModel user = service.UserDetails(id, mapper);
            if(user == null)
                return RedirectToAction("Error");
            return View(user);
        }
        [HttpGet]
        public IActionResult ShowWishlist(string name)
        {
            return View(Wishlist(name));
        }
        [HttpGet]
        public IActionResult ShowDranklist(string name)
        {
            return View(Dranklist(name));
        }
        [HttpGet]
        public IActionResult ShowReviews(string name)
        {
            var reviewList = service.UserReview(name);
            return View(reviewList);
        }
        public IActionResult DranklistRemove(int beerId, string name)
        {
            int userId = service.UserId(name);
            service.RemoveFromDranklist(beerId, userId);
            return View("ShowDranklist", Dranklist(name));
        }
        public IActionResult WishlistRemove(int beerId, string name)
        {
            int userId = service.UserId(name);
            service.RemoveFromWishlist(beerId, userId);
            return View("ShowWishlist", Wishlist(name));
        }
        private ICollection<BeerViewModel> Wishlist(string name)
        {
            var raw = service.UserWishlist(name, mapper);
            return mapper.Map<ICollection<BeerViewModel>>(raw);
        }
        private ICollection<BeerViewModel> Dranklist(string name)
        {
            var raw = service.UserDranklist(name, mapper);
            return mapper.Map<ICollection<BeerViewModel>>(raw);
        }



    }
}

BeerOverflow.Web/Views/Shared/_BeerRatingPartial.cshtml
<!DOCTYPE html>
<html>
<head>
    <link rel="stylesheet" href="~/css/ratingStars.css" />
</head>
<body>
    <form class="rating" asp-controller="Beers" asp-action="RateBeer" asp-route-beerId="@Model.Id" method="post">
        <input  type="submit" name="rating" value="5" id="5"><label for="5">☆</label>
        <input  type="submit" name="rating" value="4" id="4"><label for="4">☆</label>
        <input  type="submit" name="rating" value="3" id="3"><label for="3">☆</label>
        <input  type="submit" name="rating" value="2" id="2"><label for="2">☆</label>
        <input  type="submit" name="rating" value="1" id="1"><label for="1">☆</label>
    </form>
</body>
</html>

BeerOverflow.Web/Views/Shared/_Favicons.cshtml
<link rel="apple-touch-icon" sizes="57x57" href="/apple-icon-57x57.png">
<link rel="apple-touch-icon" sizes="60x60" href="/apple-icon-60x60.png">
<link rel="apple-touch-icon" sizes="72x72" href="/apple-icon-72x72.png">
<link rel="apple-touch-icon" sizes="76x76" href="/apple-icon-76x76.png">
<link rel="apple-touch-icon" sizes="114x114" href="/apple-icon-114x114.png">
<link rel="apple-touch-icon" sizes="120x120" href="/apple-icon-120x120.png">
<link rel="apple-touch-icon" sizes="144x144" href="/apple-icon-144x144.png">
<link rel="apple-touch-icon" sizes="152x152" href="/apple-icon-152x152.png">
<link rel="apple-touch-icon" sizes="180x180" href="/apple-icon-180x180.png">
<link rel="icon" type="image/png" sizes="192x192" href="/android-icon-192x192.png">
<link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="96x96" href="/favicon-96x96.png">
<link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
<link rel="manifest" href="/manifest.json">
<meta name="msapplication-TileColor" content="#ffffff">
<meta name="msapplication-TileImage" content="/ms-icon-144x144.png">
<meta name="theme-color" content="#ffffff">

BeerOverflow.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">


<head>

    @await Html.PartialAsync("_Favicons");

    <style>        .navbar-nav {
            background-color:transparent !important
        }

    </style>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - BeerOverFlow</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <link rel="stylesheet" href="~/css/background.css" />
</head>
<body>
    <header>

        <nav class="navbar navbar-expand-sm navbar-toggleable-sm   box-shadow mb-3">
            <div class="container">
               @* <a class= "text-light  navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">BeerOverFlow</a>*@
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse ">
                    <partial name="_LoginPartial" />
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-light"  asp-area="" asp-controller="Home" asp-action="Index"><h4>Home</h4></a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-light" asp-area="" asp-controller="Beers" asp-action="ListBeers"><h4>Beers</h4></a>
                        </li>                  
                        <li class="nav-item">  
                            <a class="nav-link text-light" asp-area="" asp-controller="Brewery" asp-action="ListBreweries"><h4>Breweries</h4></a>
                        </li>                  
                        <li class="nav-item">  
                            <a class="nav-link text-light" asp-area="" asp-controller="Country" asp-action="ListCountries"><h4>Countries</h4></a>
                        </li>
                        @if (User.IsInRole("Admin"))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-light" asp-area="" asp-controller="User" asp-action="ListUsers"><h4>Users</h4></a>
                            </li>
                        }
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>
    @*<footer class="border-top footer text-muted">
            <div class="container">
                &copy; 2020 - BeerOverFlow - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
            </div>
        </footer>*@
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>

    @RenderSection("Scripts", required: false)
</body>
</html>

BeerOverflow.Web/Views/Shared/_ListBeerReviewsPartial.cshtml
@model BeerOverflow.Services.ModelsDTo.WebModels.BeerDetailsModel
<html lang="en">
<head>
    <title>Bootstrap 4 Blog Post Comments Section Design</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="~/css/reviewListing.css" />
</head>
<body>
    <div class="container">
        <div class="row">
            <div class="col-12">
                <div class="comments">

                    <br>
                    @foreach (var review in Model.Reviews)
                    {

                        @if (!review.IsDeleted)
                        {
                            <div class="comment-box">
                                <span class="commenter-name">
                                    <a href="#">@review.User.UserName</a> <span class="comment-time"></span>
                                </span>
                                <p class="comment-txt more">@review.Text</p>
                                <div class="comment-meta">
                                    <form asp-controller="Review" asp-action="LikeReview" asp-route-id=@review.ReviewId asp-route-beerId=@Model.Id>
                                        <button class="comment-like"><i class="fa fa-thumbs-o-up" aria-hidden="true"></i>@review.PositiveVotes</button>
                                    </form>
                                    <form asp-controller="Review" asp-action="DislikeReview" asp-route-id=@review.ReviewId asp-route-beerId=@Model.Id>
                                        <button class="comment-dislike"><i class="fa fa-thumbs-o-down" aria-hidden="true"></i>@review.NegativeVotes</button>
                                    </form>
                                    @*<button class="comment-dislike">
                                        <i class="fa fa-thumbs-o-down" aria-hidden="true"></i> @review.NegativeVotes
                                    </button>*@
                                </div>
                                @if (!review.Flagged)
                                {

                                    <form asp-controller="Review" asp-action="FlagReview" asp-route-id=@review.ReviewId asp-route-beerId=@Model.Id>
                                        <button class="flag-button" aria-hidden="true">Report</button>
                                    </form>
                                }
                                else
                                {
                                    <p>This review has been reported.</p>
                                }
                            </div>
                        }

                    }
                    @if (User.Identity.IsAuthenticated)
                    {
                        <form asp-controller="Review" asp-action="PostReview" method="post" asp-route-beerId="@Model.Id">
                            <div class="comment-box add-comment">
                                <span class="commenter-name">
                                    <input type="text" placeholder="Add a public reiew" name="reviewText">
                                    <button type="submit" class="btn btn-default">POST</button>
                                </span>
                            </div>
                        </form>
                    }
                </div>
            </div>
        </div>
    </div>
</body>
</html>
<script>
    // Reply box popup JS
    $(document).ready(function () {
        $(".reply-popup").click(function () {
            $(".reply-box").toggle();
        });
    });
</script>